<?php
class pluginYouTubeEmbed extends Plugin {
    public function init()
    {
        $this->dbFields = array();
    }
    public function siteHead()
    {
        echo '<style>
                .youtube-embed {
                    position: relative;
                    padding-bottom: 56.25%;
                    height: 0;
                    overflow: hidden;
                    margin-bottom: 10px;
                }
                .youtube-embed iframe {
                    position: absolute;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                    frameborder: 0;
                    allow: "accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture";
                    allowfullscreen;
                }
              </style>';
    }
    public function siteBodyEnd() {
        echo <<<HTML
    <script>
    document.addEventListener("DOMContentLoaded", function() {
        function createYouTubeEmbed(youtubeId) {
            var div = document.createElement('div');
            div.className = 'youtube-embed';
            div.innerHTML = '<iframe src="https://www.youtube.com/embed/' + youtubeId + '" allowfullscreen></iframe>';
            return div;
        }
        var paragraphs = document.querySelectorAll('p');
        paragraphs.forEach(function(p) {
            var html = p.innerHTML;
            var regex = /\\s*\\[youtube=(.*?)\\]\\s*/g;
            var match, hasReplacement = false;
            while (match = regex.exec(html)) {
                var youtubeEmbed = createYouTubeEmbed(match[1]);
                if (!hasReplacement) {
                    p.parentNode.replaceChild(youtubeEmbed, p);
                    hasReplacement = true;
                } else {
                    p.parentNode.insertBefore(youtubeEmbed, p.nextSibling);
                }
            }
        });
    });
    </script>
    HTML;
    }
}